<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTroubleConditionTypeEnum ArrayType
 * @subpackage Arrays
 */
class ArrayOfTroubleConditionTypeEnum extends AbstractStructArrayBase
{
    /**
     * The TroubleConditionTypeEnum
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $TroubleConditionTypeEnum;
    /**
     * Constructor method for ArrayOfTroubleConditionTypeEnum
     * @uses ArrayOfTroubleConditionTypeEnum::setTroubleConditionTypeEnum()
     * @param string[] $troubleConditionTypeEnum
     */
    public function __construct(array $troubleConditionTypeEnum = array())
    {
        $this
            ->setTroubleConditionTypeEnum($troubleConditionTypeEnum);
    }
    /**
     * Get TroubleConditionTypeEnum value
     * @return string[]|null
     */
    public function getTroubleConditionTypeEnum()
    {
        return $this->TroubleConditionTypeEnum;
    }
    /**
     * Set TroubleConditionTypeEnum value
     * @uses \CustomerManagement\EnumType\TroubleConditionTypeEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\TroubleConditionTypeEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $troubleConditionTypeEnum
     * @return \CustomerManagement\ArrayType\ArrayOfTroubleConditionTypeEnum
     */
    public function setTroubleConditionTypeEnum(array $troubleConditionTypeEnum = array())
    {
        $invalidValues = array();
        foreach ($troubleConditionTypeEnum as $arrayOfTroubleConditionTypeEnumTroubleConditionTypeEnumItem) {
            if (!\CustomerManagement\EnumType\TroubleConditionTypeEnum::valueIsValid($arrayOfTroubleConditionTypeEnumTroubleConditionTypeEnumItem)) {
                $invalidValues[] = var_export($arrayOfTroubleConditionTypeEnumTroubleConditionTypeEnumItem, true);
            }
        }
        if (!empty($invalidValues)) {
            throw new \InvalidArgumentException(sprintf('Value(s) "%s" is/are invalid, please use one of: %s', implode(', ', $invalidValues), implode(', ', \CustomerManagement\EnumType\TroubleConditionTypeEnum::getValidValues())), __LINE__);
        }
        $this->TroubleConditionTypeEnum = $troubleConditionTypeEnum;
        return $this;
    }
    /**
     * Add item to TroubleConditionTypeEnum value
     * @uses \CustomerManagement\EnumType\TroubleConditionTypeEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\TroubleConditionTypeEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \CustomerManagement\ArrayType\ArrayOfTroubleConditionTypeEnum
     */
    public function addToTroubleConditionTypeEnum($item)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\TroubleConditionTypeEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $item, implode(', ', \CustomerManagement\EnumType\TroubleConditionTypeEnum::getValidValues())), __LINE__);
        }
        $this->TroubleConditionTypeEnum[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \CustomerManagement\EnumType\TroubleConditionTypeEnum::valueIsValid()
     * @param string $item
     * @return \CustomerManagement\ArrayType\ArrayOfTroubleConditionTypeEnum
     */
    public function add($item)
    {
        if (!\CustomerManagement\EnumType\TroubleConditionTypeEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $item, implode(', ', \CustomerManagement\EnumType\TroubleConditionTypeEnum::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TroubleConditionTypeEnum
     */
    public function getAttributeName()
    {
        return 'TroubleConditionTypeEnum';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfTroubleConditionTypeEnum
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
